(in-package #:lisp-sentry)


(defun smaller-than-8k-p (str)
  (<= (babel:string-size-in-octets str)
      8192))

(deftype message-string () '(and string (satisfies smaller-than-8k-p)))

(define-json-object (message-interface)
  "The [Message Interface](https://develop.sentry.dev/sdk/data-model/event-payloads/message)
carries a log message that describes an event or error.

See `MAKE-MESSAGE-INTERFACE`, `ADD-MESSAGE`"
  (formatted "" :type message-string
                :documentation "the fully formatted message."))

(defun add-message (event control &rest args)
  "Adds `MESSAGE-INTERFACE` to given `EVENT` using `FORMAT` on given `CONTROL`
and `ARGS`."
  (push
   (make-message-interface :formatted (apply #'format nil control args))
   (event-interfaces event))
  event)

(defmethod dump-event-interface ((interface message-interface))
  `("logentry"
    ,(dump-message-interface interface)))
